//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39A3EEB90261.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39A3EEB90261.cm

//## begin module%39A3EEB90261.cp preserve=no
//## end module%39A3EEB90261.cp

//## Module: EinsteinResponse%39A3EEB90261; Package body
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Data/Detector/EinsteinResponse.cxx

//## begin module%39A3EEB90261.additionalIncludes preserve=no
//## end module%39A3EEB90261.additionalIncludes

//## begin module%39A3EEB90261.includes preserve=yes
//## end module%39A3EEB90261.includes

// SpectralData
#include <XSModel/Data/SpectralData.h>
// typeinfo
#include <typeinfo>
// EinsteinResponse
#include <XSModel/Data/Detector/EinsteinResponse.h>
//## begin module%39A3EEB90261.declarations preserve=no
//## end module%39A3EEB90261.declarations

//## begin module%39A3EEB90261.additionalDeclarations preserve=yes
//## end module%39A3EEB90261.additionalDeclarations


// Class EinsteinResponse 

EinsteinResponse::EinsteinResponse()
  //## begin EinsteinResponse::EinsteinResponse%3641DCBB02DD_const.hasinit preserve=no
  //## end EinsteinResponse::EinsteinResponse%3641DCBB02DD_const.hasinit
  //## begin EinsteinResponse::EinsteinResponse%3641DCBB02DD_const.initialization preserve=yes
  //## end EinsteinResponse::EinsteinResponse%3641DCBB02DD_const.initialization
{
  //## begin EinsteinResponse::EinsteinResponse%3641DCBB02DD_const.body preserve=yes
  //## end EinsteinResponse::EinsteinResponse%3641DCBB02DD_const.body
}

EinsteinResponse::EinsteinResponse(const EinsteinResponse &right)
  //## begin EinsteinResponse::EinsteinResponse%3641DCBB02DD_copy.hasinit preserve=yes
      : RealResponse(right),EinsteinIO(right)
  //## end EinsteinResponse::EinsteinResponse%3641DCBB02DD_copy.hasinit
  //## begin EinsteinResponse::EinsteinResponse%3641DCBB02DD_copy.initialization preserve=yes
  //## end EinsteinResponse::EinsteinResponse%3641DCBB02DD_copy.initialization
{
  //## begin EinsteinResponse::EinsteinResponse%3641DCBB02DD_copy.body preserve=yes
  //## end EinsteinResponse::EinsteinResponse%3641DCBB02DD_copy.body
}


EinsteinResponse::~EinsteinResponse()
{
  //## begin EinsteinResponse::~EinsteinResponse%3641DCBB02DD_dest.body preserve=yes
  //## end EinsteinResponse::~EinsteinResponse%3641DCBB02DD_dest.body
}



//## Other Operations (implementation)
EinsteinResponse* EinsteinResponse::clone () const
{
  //## begin EinsteinResponse::clone%380DF4C2A338.body preserve=yes
  //## end EinsteinResponse::clone%380DF4C2A338.body

  return new EinsteinResponse(*this);
}

bool EinsteinResponse::fileFormat (const string& fileName, XspecDataIO::DataType type)
{
  //## begin EinsteinResponse::fileFormat%39A3ED9502D0.body preserve=yes
  return EinsteinIO::fileFormat(fileName,type);
  //## end EinsteinResponse::fileFormat%39A3ED9502D0.body
}

void EinsteinResponse::groupQuality ()
{
  //## begin EinsteinResponse::groupQuality%39FEF1B5002A.body preserve=yes
  //## end EinsteinResponse::groupQuality%39FEF1B5002A.body
}

void EinsteinResponse::setArrays ()
{
  //## begin EinsteinResponse::setArrays%3A01E4140060.body preserve=yes
  //## end EinsteinResponse::setArrays%3A01E4140060.body
}

void EinsteinResponse::setDescription (size_t spectrumNumber, size_t groupNumber)
{
  //## begin EinsteinResponse::setDescription%3A01E419023C.body preserve=yes
  //## end EinsteinResponse::setDescription%3A01E419023C.body
}

size_t EinsteinResponse::read (const string& fileName, bool readFlag)
{
  // do nothing (yet)

  //## begin EinsteinResponse::read%3A228ED10113.body preserve=yes
  return 1;   // for now
  //## end EinsteinResponse::read%3A228ED10113.body
}

void EinsteinResponse::closeSourceFiles ()
{
  //## begin EinsteinResponse::closeSourceFiles%3A39410F02E4.body preserve=yes
  //## end EinsteinResponse::closeSourceFiles%3A39410F02E4.body
}

void EinsteinResponse::copy (const RealResponse& right)
{
  //## begin EinsteinResponse::copy%3A955CDD00FE.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  EinsteinResponse __temp( static_cast<const EinsteinResponse&>(right) );
  swap(__temp);     
  //## end EinsteinResponse::copy%3A955CDD00FE.body
}

void EinsteinResponse::Swap (RealResponse& right) throw ()
{
  //## begin EinsteinResponse::Swap%3A95889402B1.body preserve=yes
  EinsteinResponse& that = static_cast<EinsteinResponse&>(right);
  RealResponse::Swap(right);
  EinsteinIO::swap(that);  
  //## end EinsteinResponse::Swap%3A95889402B1.body
}

// Additional Declarations
  //## begin EinsteinResponse%3641DCBB02DD.declarations preserve=yes
  //## end EinsteinResponse%3641DCBB02DD.declarations

//## begin module%39A3EEB90261.epilog preserve=yes
//## end module%39A3EEB90261.epilog
